#
# $Id$
#   
# Copyright (C) 2003 Kai Sterker <kaisterker@linuxgames.com>
# Part of the Adonthell Project http://adonthell.linuxgames.com
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY.
#
# See the COPYING file for more details.
#

import item
import adonthell

#
# Class for basic projectile weapons.
#
class projectile (item.item):

    def combine (self, item):
        instance = item.get_instance ()
        
        # -- projectiles can be poisoned
        if instance.is_a ("Poison") and not self.is_a ("poisoned"):
        
            # -- create a (new) immutable item from projectile and poison
            name = self.Name + " of " + instance.Name
            
            # -- see whether this combination already exists
            result = adonthell.item_storage_get (name)
            
            # -- otherwise create it
            if result == None:
                result = adonthell.item_base (0)
                result.create_instance ("projectile", "projectile")
                result.set_max_stack (self.this.max_stack ())
                result.thisown = 0
                
                pyres = result.get_instance ()
                for category in self.Categories:
                    pyres.add_category (category)
                pyres.add_category ("poisoned")
                pyres.Name = name
                pyres.Value = self.Value + instance.Value / instance.MaxCharge
                
                # -- add it to item storage
                adonthell.item_storage_add (result)
                
            # -- remove poison charge
            instance.Charge = instance.Charge - 1
            
            # -- destroy if no charges left
            if instance.Charge == 0: instance.destroy ()
            
            return result
        
        # -- combination failed
        return None
